#ifndef _ANIMATION_MANAGER_H_
#define _ANIMATION_MANAGER_H_

#include "cocos2d.h"
#include "Singleton.h"
USING_NS_CC;

enum{
	aFall,
	aOnNormalBoardLeft,
	aOnNormalBoardRight,
	aOnStarBoardLeft,
	aOnStarBoardRight,
	aRollingBoard,
	aRotateLeftBoard,
	aRotateRightBoard,
	aSpringBoard,
	aOnRollingBoard
};


class AnimationManager : public Singleton<AnimationManager>{
public:
	AnimationManager();
	~AnimationManager();
	//ʼģ滺
	bool initAnimationMap();
	//ֵõһģ
	CCAnimation* getAnimation(int key);
	//һʵ
	CCAnimate* createAnimate(int key);
	//һʵ
	CCAnimate* createAnimate(const char* key);
private:
	CCSpriteBatchNode *_gameBatchNode;
	CCAnimation* createBobFallAnimation();
	CCAnimation* createBobOnNormalBoardLeftAnimation();
	CCAnimation* createBobOnNormalBoardRightAnimation();
	CCAnimation* createBobOnStarBoardLeftAnimation();
	CCAnimation* createBobOnStarBoardRightAnimation();
	CCAnimation* createRollingBoardAnimation();
	CCAnimation* createRotateLeftBoardAnimation();
	CCAnimation* createRotateRightBoardAnimation();
	CCAnimation* createSpringBoardAnimation();
};

//嶯ʵı
#define sAnimationMgr AnimationManager::instance()

#endif